/*$Id: io_error.h,v 26.44 2007/07/25 16:36:12 al Exp $ -*- C++ -*-
 * data for error and exception handling
 *
 * Copyright (C) 2001 Albert Davis
 * Author: Albert Davis <aldavis@ieee.org>
 *
 * This file is part of "Gnucap", the Gnu Circuit Analysis Package
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
//testing=trivial 2006.07.17
#ifndef bERROR
#include "md.h"
/*--------------------------------------------------------------------------*/
/* arg to error() (badness) to decide severity of exception */
#define	bNOERROR	0
#define bTRACE		1
#define bLOG		2
#define bDEBUG		3
#define bPICKY		4
#define	bWARNING	5
#define bDANGER		6
#define bERROR		7
#define bEXIT		8
#define bDISASTER	9
	void	  error(int,const char*,...);
	void	  error(int,const std::string&);
/*--------------------------------------------------------------------------*/
struct Exception {
  std::string _message;
  const std::string& message()const {return _message;}
};
struct Exception_No_Match :public Exception{};
struct Exception_Too_Many :public Exception{
  int _requested, _max;
  Exception_Too_Many(int requested, int max)
    :_requested(requested), _max(max) {
    extern std::string to_string(int);
    _message = "too many: requested=" + to_string(_requested) + " max=" + to_string(_max);
  }
};
struct Exception_Cant_Set_Type :public Exception{
  std::string _from, _to;
  Exception_Cant_Set_Type(const std::string& from, const std::string& to)
    :_from(from), _to(to) {
    _message = "can't set type from \"" + _from + "\" to \"" + _to + "\"";
  }
};
#if 0
struct Exception_Model_Type_Mismatch :public Exception{
  std::string _device, _need_type, _got_type;
  Exception_Model_Type_Mismatch(const std::string& d, const std::string& n, const std::string& g)
    :_device(d), _need_type(n), _got_type(g) {
  }
};
#endif
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
